<!DOCTYPE html>
<html lang="en">

<head>
    <title>Pizza 365 - Order List</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container">
        <div class="col-sm-12 text-center mt-4 mb-4">
            <h3><b>DANH SÁCH ĐƠN HÀNG</b></h3>
        </div>
        <table class="table table-bordered table-striped table-hover text-center" id="table-orders">
            <thead>
                <tr>
                    <th>Order ID</th>
                    <th>Kích Cỡ Combo</th>
                    <th>Loại Pizza</th>
                    <th>Nước Uống</th>
                    <th>Thành Tiền</th>
                    <th>Họ và Tên</th>
                    <th>Số Điện Thoại</th>
                    <th>Trạng Thái</th>
                    <th>Chi Tiết</th>
                </tr>
            </thead>
        </table>
    </div>
    <!-- Modal chi tiết -->
    <div class="modal fade" id="modal-details">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Chi Tiết Đơn Hàng</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Order ID</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-orderid">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Cỡ Combo</label>
                        </div>
                        <div class="col-sm-9">
                            <select id="select-combo" class="form-control">
                                <option value="S">Nhỏ</option>
                                <option value="M">Vừa</option>
                                <option value="L">Lớn</option>
                            </select>
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Đường Kính Pizza</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-duongkinh">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Sườn Nướng</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-suon">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Đồ Uống</label>
                        </div>
                        <div class="col-sm-9">
                            <select id="select-drink" class="form-control"></select>
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Số Lượng Nước Uống</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-number-drink">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Voucher ID</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-voucherid">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Loại Pizza</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-pizza-type">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Salad</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-salad">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Thành Tiền</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-price">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Giảm Giá</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-discount">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Họ và Tên</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-name">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Email</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-email">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Số Điện Thoại</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-phone">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Địa chỉ</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-address">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Lời Nhắn</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-message">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Trạng Thái Đơn Hàng</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-order-status">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Ngày Tạo Đơn</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-create-date">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm 3">
                            <label>Ngày Cập Nhật</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" class="form-control" id="inp-update-date">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col text-right">
                            <button class="btn btn-warning" id="btn-confirm">Confirm</button>
                            <button class="btn btn-danger" id="btn-cancel">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    $(document).ready(function () {


        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
        const gDRINKS_URL = "http://42.115.221.44:8080/devcamp-pizza365/drinks";

        const gCOLUMNS = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "chiTiet"];

        const gORDERID_COL = 0;
        const gCOMBO_COL = 1;
        const gPIZZA_TYPE_COL = 2;
        const gDRINK_COL = 3;
        const gPRICE_COL = 4;
        const gNAME_COL = 5;
        const gPHONE_COL = 6;
        const gSTATUS_COL = 7;
        const gDETAIL_COL = 8;

        var gDATATABLE = $("#table-orders").DataTable({
            columns: [
                { data: gCOLUMNS[gORDERID_COL] },
                { data: gCOLUMNS[gCOMBO_COL] },
                { data: gCOLUMNS[gPIZZA_TYPE_COL] },
                { data: gCOLUMNS[gDRINK_COL] },
                { data: gCOLUMNS[gPRICE_COL] },
                { data: gCOLUMNS[gNAME_COL] },
                { data: gCOLUMNS[gPHONE_COL] },
                { data: gCOLUMNS[gSTATUS_COL] },
                { data: gCOLUMNS[gDETAIL_COL] }
            ],
            columnDefs: [
                {
                    targets: gDETAIL_COL,
                    defaultContent: `
                <i class="fas fa-info-circle btn-detail" data-toggle="tooltip" title="Chi tiết" style="cursor:pointer"></i>
                `
                }
            ]
        })

        var gOrderID;
        var gID;

        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        // gán sự kiện tải trang
        onPageLoading();
        // gán sự kiện cho icon chi tiết
        $("#table-orders").on("click", ".btn-detail", onBtnDetailClick);
        // gán sự kiện cho nút Confirm
        $("#btn-confirm").click(onBtnConfirmClick);
        // gán sự kiện cho nút Cancel
        $("#btn-cancel").click(onBtnCancelClick);

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm xử lý sự kiện tải trang
        function onPageLoading() {
            callAPIOrders();
            callAPIDrinks();
        }
        // Hàm xử lý sự kiện ấn icon chi tiết
        function onBtnDetailClick() {
            var vSelectedRow = $(this).closest("tr");
            var vDataRow = gDATATABLE.row(vSelectedRow).data();
            gOrderID = vDataRow.orderId;
            gID = vDataRow.id;

            $("#modal-details").modal("show");
            callAPIOrderDetails();
        }
        // Hàm xử lý sự kiện nút Confirm
        function onBtnConfirmClick() {
            var vConfirmedOrder = {
                trangThai: "confirmed"
            }
            // B1: Thu thập (ko cần)
            // B2: Kiểm tra (ko cần)
            // B3: Gọi API
            sendConfirmRequestToAPI(vConfirmedOrder);
            // B4: Xử lý hiển thị
            alert("Cập nhật thông tin đơn hàng thành công!");
            $("#modal-details").modal("hide");
            onPageLoading();
        }
        // Hàm xử lý sự kiện nút Cancel
        function onBtnCancelClick() {
            var vCancelOrder = {
                trangThai: "cancel"
            }
            // B1: Thu thập (ko cần)
            // B2: Kiểm tra (ko cần)
            // B3: Gọi API
            sendCancelRequestToAPI(vCancelOrder);
            // B4: Xử lý hiển thị
            alert("Cập nhật thông tin đơn hàng thành công!");
            $("#modal-details").modal("hide");
            onPageLoading();
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
        // Hàm gọi API để load orders
        function callAPIOrders() {
            $.ajax({
                url: gBASE_URL,
                type: "GET",
                success: function (paramSuccess) {
                    console.log(paramSuccess);
                    loadDataToTable(paramSuccess);
                },
                error: function (error) {
                    console.log(error.responseText);
                }
            })
        }
        // Hàm load dữ liệu ra bảng
        function loadDataToTable(paramOrders) {
            gDATATABLE.clear();
            gDATATABLE.rows.add(paramOrders);
            gDATATABLE.draw();
        }
        // Hàm gọi API drinks
        function callAPIDrinks() {
            $.ajax({
                url: gDRINKS_URL,
                type: "GET",
                success: function (paramDrinks) {
                    console.log(paramDrinks);
                    loadDrinksToSelect(paramDrinks);
                },
                error: function (error) {
                    console.log(error.responseText);
                }
            })
        }
        // Hàm đổ dữ liệu drinks vào ô select
        function loadDrinksToSelect(paramDrink) {
            var vSelectDrinks = $("#select-drink");
            for (var i = 0; i < paramDrink.length; i++) {
                $("<option>", {
                    value: paramDrink[i].maNuocUong,
                    text: paramDrink[i].tenNuocUong
                }).appendTo(vSelectDrinks);
            }
        }
        // Hàm call API đổ dữ liệu vào form
        function callAPIOrderDetails() {
            $.ajax({
                url: gBASE_URL + "/" + gOrderID,
                type: "GET",
                success: function (paramDetails) {
                    console.log(paramDetails);
                    loadDetailsToForm(paramDetails);
                },
                error: function (error) {
                    console.log(error.responseText);
                }
            })
        }
        // Hàm đổ dữ liệu vào form
        function loadDetailsToForm(paramOrderDetails) {
            $("#inp-orderid").val(paramOrderDetails.orderId);
            $("#select-combo").val(paramOrderDetails.kichCo);
            $("#inp-duongkinh").val(paramOrderDetails.duongKinh + "cm");
            $("#inp-suon").val(paramOrderDetails.suon);
            $("#select-drink").val(paramOrderDetails.idLoaiNuocUong);
            $("#inp-number-drink").val(paramOrderDetails.soLuongNuoc);
            $("#inp-voucherid").val(paramOrderDetails.idVourcher);
            $("#inp-pizza-type").val(paramOrderDetails.loaiPizza);
            $("#inp-salad").val(paramOrderDetails.salad + "gr");
            $("#inp-price").val(paramOrderDetails.thanhTien);
            $("#inp-discount").val(paramOrderDetails.giamGia);
            $("#inp-name").val(paramOrderDetails.hoTen);
            $("#inp-email").val(paramOrderDetails.email);
            $("#inp-phone").val(paramOrderDetails.soDienThoai);
            $("#inp-address").val(paramOrderDetails.diaChi);
            $("#inp-message").val(paramOrderDetails.loiNhan);
            $("#inp-order-status").val(paramOrderDetails.trangThai);
            $("#inp-create-date").val(paramOrderDetails.ngayTao);
            $("#inp-update-date").val(paramOrderDetails.ngayCapNhat);
        }
        // Hàm gọi API confirm
        function sendConfirmRequestToAPI(paramConfirmedOrder) {
            $.ajax({
                url: gBASE_URL + "/" + gID,
                type: "PUT",
                data: JSON.stringify(paramConfirmedOrder),
                contentType: "application/json;charset=UTF-8",
                success: function (paramConfirm) {
                    console.log(paramConfirm);
                },
                error: function (error) {
                    console.log(error.responseText);
                }
            })
        }
        // Hàm gọi API cancel
        function sendCancelRequestToAPI(paramCancelOrder) {
            $.ajax({
                url: gBASE_URL + "/" + gID,
                type: "PUT",
                data: JSON.stringify(paramCancelOrder),
                contentType: "application/json;charset=UTF-8",
                success: function (paramCancel) {
                    console.log(paramCancel);
                },
                error: function (error) {
                    console.log(error.responseText);
                }
            })
        }

    })
</script>

</html>
